/* 
 * Copyright (C) 2004  Free Software Initiative of Japan
 *
 * This file is subject to the terms and conditions of the GNU Lesser
 * General Public License version 2.1 (or later).
 *
 */

/**
 * flush_cache - flush the cache to maintain memory integrity
 * @how: Number to specify how/which cache is flushed (machine dependent)
 * @...: When @how > 0, can have other arguments
 *
 * Flush the cache to maintain memory integrity.  @how == 0 means maximum
 * integrity, that is, flush all the cache to main memory (this semantics
 * is machine independent).
 * For the value @how > 0, the meaning is machine dependent, e.g.,
 * @how == 1 only flush specific cache line.
 */
extern int flush_cache (int how /* , ... */);
