#define ETH_ALEN 6
struct eth_addr { u8 bits[ETH_ALEN]; };
#define ETH_HLEN 14

#define ETHER_FRAME_LEN 1514

struct eth_frame {
  u8 dst[ETH_ALEN];
  u8 src[ETH_ALEN];
  u8 type[2];
  u8 data[ETHER_FRAME_LEN - ETH_ALEN*2 -2];
};

#define ETH_IDLE	 		0

struct eth_packet {
  unsigned int state : 2;
  unsigned int data_to_send: 1;
  unsigned int tx_completion_wait: 1;
  unsigned int wait: 12;
  u16 length;
  u16 pad;		/* 6-bytes, so that IP header is on the alignment */
  u8 data[ETHER_FRAME_LEN];
};

extern struct eth_addr node_eth_addr;

#define	ETHERTYPE_IP		0x0800
#define	ETHERTYPE_ARP		0x0806
#define	ETHERTYPE_IPv6		0x86dd

extern int eth_init (struct eth_packet *p);
extern int eth_mc_setup_ipv6 (void);

extern void transmit_prepare (struct eth_packet *p);

/*
 * Return value:
 * -1: packet not received, nothing happened
 *  0: packet received, not handled by the maton, please take it and process it
 *  1: Handled already by the maton, please invoke the maton again soon
 */
extern int eth_maton (struct eth_packet *p);
