/* 
 * Copyright (C) 2004 Free Software Initiative of Japan
 *
 * This file is subject to the terms and conditions of the GNU Lesser
 * General Public License version 2.1 (or later).
 *
 */
	.macro LDIMM reg x
	seth	\reg, #high(\x)
	or3	\reg, \reg, #low(\x)
	.endm

	.global __stack
	.global __data_start_rom, _data, _edata
	.global boot

	.text
	.global start
start:
	LDIMM	r2, cache_init
	/* Initilalize PSW */
	ldi	r0, #0x00		/* use SPI, disable interrupt */
	mvtc	r0, psw	
	/* MMU unset */
	ldi	r1, #-1
	slli	r1, #16			/* MMU control address:	0xffff0000 */
	st	r0, @r1
	jmp	r2

cache_init:
	ldi	r0, #-1
	ldi	r1, #0x73
	ldi	r2, #0x40
	stb	r1, @r0
	.fillinsn
1:	ldb	r1, @r0
	and	r1, r2
	bnez	r1, 1b

	/* Setup the stack pointer (we know that lower word is 0x0000) */
	/* NOTE: It is phisical address (even if we use MMU). */
	seth	r0, #high(__stack)
	mvtc	r0, spi

	/* Clear BSS */
	ldi	r0, #0
	LDIMM	r2, __bss_start
	LDIMM	r3, _end
	.fillinsn
1:	st	r0, @-r3
	bne	r2, r3, 1b

	/* Copy data segment */
	LDIMM	r1, __data_start_rom
	LDIMM	r2, (_data - 4)
	LDIMM	r3, (_edata - 4)
	.fillinsn
1:	ld	r0, @r1+
	st	r0, @+r2
	bne	r2, r3, 1b

	/* LED OFF */
	ldi	r0, #0x0000
	LDIMM	r1, 0xa4c14002
	sth	r0, @r1

	LDIMM	r0, boot
	jmp	r0

	/* Just in case... */
	/* LED ON */
	ldi	r0, #0x0003
	LDIMM	r1, 0xa4c14002
	sth	r0, @r1
	.fillinsn
1:	bra	1b
	.end
