/* 
 * Copyright (C) 2004 Free Software Initiative of Japan
 *
 * This file is subject to the terms and conditions of the GNU Lesser
 * General Public License version 2.1 (or later).
 *
 */
	.macro LDIMM reg x
	seth	\reg, #high(\x)
	or3	\reg, \reg, #low(\x)
	.endm

	.macro NULL_HANDLER
1:	bra.s	1b || nop
	nop
	nop
	nop
	nop
	nop
	nop
	.endm

	.macro NULL_HANDLER_SMALL
1:	bra.s	1b ||	nop
	.endm

	.global __stack
	.global __data_start_rom, _data, _edata
	.global boot

	.text
	.global start
start:
	ldi	r0, #low(psw_init_addr)
	ld	r2, @r0
	ldi	r0, #1
mmu_init:
	ldi	r1, #-1
	slli	r1, #16		/* MMU control address:	0xffff0000 */
	st	r0, @r1
	jmp	r2

eit_sbi:
	NULL_HANDLER

eit_rie:
	NULL_HANDLER

eit_ae:
	NULL_HANDLER

trap0:
	NULL_HANDLER_SMALL
trap1:
	NULL_HANDLER_SMALL
trap2:
	NULL_HANDLER_SMALL
trap3:
	NULL_HANDLER_SMALL
trap4:
	NULL_HANDLER_SMALL
trap5:
	NULL_HANDLER_SMALL
trap6:
	NULL_HANDLER_SMALL
trap7:
	NULL_HANDLER_SMALL
trap8:
	NULL_HANDLER_SMALL
trap9:
	NULL_HANDLER_SMALL
trapA:
	NULL_HANDLER_SMALL
trapB:
	NULL_HANDLER_SMALL
trapC:
	NULL_HANDLER_SMALL
trapD:
	NULL_HANDLER_SMALL
trapE:
	NULL_HANDLER_SMALL
trapF:
	NULL_HANDLER_SMALL

eit_ei:
	NULL_HANDLER
	NULL_HANDLER
	NULL_HANDLER
	NULL_HANDLER
	NULL_HANDLER
	NULL_HANDLER
	NULL_HANDLER
	NULL_HANDLER

eit_pie:
	NULL_HANDLER

eit_ace:
	NULL_HANDLER

eit_tme:
	NULL_HANDLER

psw_init_addr:
	.long	psw_init

psw_init:
	ldi	r0, #0x00	/* Use SPI, disable interrupt */
	mvtc	r0, psw

cache_init:
	ldi	r0, #-1
	ldi	r1, #0x73
	ldi	r2, #0x40
	stb	r1, @r0
	.fillinsn
1:	ldb	r1, @r0
	and	r1, r2
	bnez	r1, 1b

eit_vector_init:
	/* Nothing to do */

r8_setup:	/* Address of SFR (Special Function Registers) */
	seth	r8, #0xa0ef

sdram_init:
	or3	r0, r8, #0x6008
	ldi	r1, #0x0182
	st	r1, @r0

	or3	r0, r8, #0x600c
	ldi	r1, #0x01
	st	r1, @r0

	.fillinsn
1:	ld	r1, @r0
	bnez	r1, 1b

	or3	r0, r8, #0x602c
	ldi	r1, #0x20
	st	r1, @r0

#define SD0TR_VAL 0x00041302
	or3	r0, r8, #0x6028
	seth	r1, #high(SD0TR_VAL)
	or3     r1, r1, #low(SD0TR_VAL)
	st      r1, @r0

#define SD0ADR_VAL 0x08000004
	or3	r0, r8, #0x6020
	seth	r1, #high(SD0ADR_VAL)
	or3	r1, r1, #low(SD0ADR_VAL)
	st	r1, @r0

#define SDRF1_VAL 0x00010705
	or3	r0, r8, #0x6004
	seth	r1, #high(SDRF1_VAL)
	or3     r1, r1, #low(SDRF1_VAL)
	st	r1, @r0

	or3	r0, r8, #0x6027
	ldi	r1, #0x01
	stb	r1, @r0

#define BSEL0CR_INIT_VAL 0x01011100	/* Flash ROM */
#define BSEL1CR_INIT_VAL 0x02011100	/* ??? PLD */
/* #define BSEL2CR_INIT_VAL 0x00008500	*//* SDRAM */
#define BSEL3CR_INIT_VAL 0x0b0b1304	/* Compact Flash */
#define BSEL4CR_INIT_VAL 0x0f0f110f	/* ??? PLD */
#define BSEL5CR_INIT_VAL 0x03033103
#define BSEL6CR_INIT_VAL 0x0fff330f
#define BSEL7CR_INIT_VAL 0x0fff330f
bsel_init:
	or3	r0, r8, #0x4ffc
	seth	r1, #high(BSEL0CR_INIT_VAL)
	or3	r1, r1, #low(BSEL0CR_INIT_VAL)
	st	r1, @+r0
	seth	r1, #high(BSEL1CR_INIT_VAL)
	or3	r1, r1, #low(BSEL1CR_INIT_VAL)
	st	r1, @+r0
#if	0
	seth	r1, #high(BSEL2CR_INIT_VAL)
	or3	r1, r1, #low(BSEL2CR_INIT_VAL)
	st	r1, @+r0
#else
	addi	r0, #4
#endif
	seth	r1, #high(BSEL3CR_INIT_VAL)
	or3	r1, r1, #low(BSEL3CR_INIT_VAL)
	st	r1, @+r0
	seth	r1, #high(BSEL4CR_INIT_VAL)
	or3	r1, r1, #low(BSEL4CR_INIT_VAL)
	st	r1, @+r0
	seth	r1, #high(BSEL5CR_INIT_VAL)
	or3	r1, r1, #low(BSEL5CR_INIT_VAL)
	st	r1, @+r0
	seth	r1, #high(BSEL6CR_INIT_VAL)
	or3	r1, r1, #low(BSEL6CR_INIT_VAL)
	st	r1, @+r0
	seth	r1, #high(BSEL7CR_INIT_VAL)
	or3	r1, r1, #low(BSEL7CR_INIT_VAL)
	st	r1, @+r0

io_init:
	ldi	r1, #0xf0
	or3	r0, r8, #0x1020		/* IO Port */
	stb	r1, @r0
	or3	r0, r8, #0x1040		/* IO Port Direction */
	stb	r1, @r0

setup_stack:
	seth	r0, #high(__stack)
	or3	r0, r0, #low(__stack)
	mvtc	r0, spi

clear_bss:
	/* Clear BSS */
	ldi	r0, #0
	LDIMM	r2, __bss_start
	LDIMM	r3, _end
	.fillinsn
1:	st	r0, @-r3
	bne	r2, r3, 1b

copy_data:
	/* Copy data segment */
	LDIMM	r1, (__data_start_rom + 0x80000000)
	LDIMM	r2, (_data - 4)
	LDIMM	r3, (_edata - 4)
	.fillinsn
1:	ld	r0, @r1+
	st	r0, @+r2
	bne	r2, r3, 1b

	/* LED-{3,4,5,6} ON */
	ldi	r0, #0x00
	or3	r1, r8, #0x1020
	stb	r0, @r1

	LDIMM	r0, boot
	jmp	r0

	/* Just in case... */
	/*  LED-{3,4,5,6} OFF */
	ldi	r0, #0xf0
	LDIMM	r1, 0xa0ef1020
	stb	r0, @r1
	.fillinsn
1:	bra	1b
	.end
