extern inline u8 peek_u8 (unsigned char *p)
{
  return *p;
}

extern inline u16 peek_u16_raw (unsigned char *p)
{
  return (*p<<8)|*(p+1);
}

extern inline u16 peek_u16_ntoh (unsigned char *p)
{
  return (*p<<8)|*(p+1);
}

extern inline u32 peek_u32_raw (unsigned char *p)
{
  return (*p<<24)|(*(p+1)<<16)|(*(p+2)<<8)|*(p+3);
}

extern inline u32 peek_u32_ntoh (unsigned char *p)
{
  return (*p<<24)|(*(p+1)<<16)|(*(p+2)<<8)|*(p+3);
}

extern inline void poke_u8 (unsigned char *p, u8 v)
{
  *p = v;
}

extern inline void poke_u16_raw (unsigned char *p, u16 v)
{
  *p++ = v>>8;
  *p = v&0xff;
}

extern inline void poke_u16_hton (unsigned char *p, u16 v)
{
  *p++ = v>>8;
  *p = v&0xff;
}

extern inline void poke_u32_raw (unsigned char *p, u32 v)
{
  *p++ = v>>24;
  *p++ = (v>>16)&0xff;
  *p++ = (v>>8)&0xff;
  *p = v&0xff;
}

extern inline void poke_u32_hton (unsigned char *p, u32 v)
{
  *p++ = v>>24;
  *p++ = (v>>16)&0xff;
  *p++ = (v>>8)&0xff;
  *p = v&0xff;
}
