/* $Id$
 *
 * Fake vmlinuz image for testing boot loader.
 *
 *  vmlinuz.S
 *
 *  Copyright (C) 2004  Free Software Initiative of Japan
 *
 * This file is subject to the terms and conditions of the GNU Lesser
 * General Public License version 2.1 (or later).
 *
 */

/*
 * NOTE: Keep this code "position independent", so that this works well
 *       among machines with different memory map.
 */

	.text
	.global start
start:
	mv	r11, r0		; bios_call_vector
	push	r1		; mem_start
	push	r2		; mem_size
	push	r12
	;;
	ldi	r0, #0x47	; 'G'
	bl	put_char
	ldi	r0, #0x4e	; 'N'
	bl	put_char
	ldi	r0, #0x55	; 'U'
	bl	put_char
	ldi	r0, #0x0d	; '\r'
	bl	put_char
	ldi	r0, #0x0a	; '\n'
	bl	put_char
	;; 
loop:	bra	loop

put_char:
	ld	r4, @r11
	jmp	r4

put_string:
	add3	r4, r11, #4
	ld	r5, @r4
	jmp	r5

	.section .rodata
kernparms:
	.space	16
	.space	16
	.space	16
	.space	14
	.byte	01, 03		/* ROOT DEVICE */
	.short	0x55AA		/* boot block signature */

	.fill 1024
	.end
